clc
clear all
A=load('picking_list_front.txt');
% A=load('picking_list_end.txt');
n=length(A);
Xdata=A(1:n,2)';
Ydata=A(1:n,3)';
Zdata=A(1:n,4)';
figure
plot3(Xdata,Ydata,Zdata,'*')
X=A(:,2:end);
p0=mean(X);
r02=mean(sqrt(sum((X-repmat(p0,[size(X,1) 1])).^2,2)));
f=@(p)(X(:,1)-p(1)).^2+(X(:,2)-p(2)).^2+(X(:,3)-p(3)).^2-p(4).^2;
p=lsqnonlin(f,[p0 r02]);
x0=p(1);y0=p(2);z0=p(3);
radii=abs(p(4))
% X=[X;p(1:3)];
x=X(:,1);
y=X(:,2);
z=X(:,3);
planeData=[x,y,z];
scatter3(x,y,z,'filled')
hold on;
plot3(p(1),p(2),p(3),'r*')
hold on
xyz0=mean(planeData,1);
centeredPlane=bsxfun(@minus,planeData,xyz0);
[U,S,V]=svd(centeredPlane);
a=V(1,3);
b=V(2,3);
c=V(3,3);
d=-dot([a b c],xyz0);

xfit = min(x):0.001:max(x);
yfit = min(y):0.001:max(y);
[XFIT,YFIT]= meshgrid (xfit,yfit);
ZFIT = -(d + a * XFIT + b * YFIT)/c;
mesh(XFIT,YFIT,ZFIT);

B=load('3Cloud1.txt');

Xdata1=B(1:4:77108,1)';
Ydata1=B(1:4:77108,2)';
Zdata1=B(1:4:77108,3)';

plot3(Xdata1,Ydata1,Zdata1,'*')

% Laxis=V(1:3,3);

% a1=0.9638;
% a2=0.0559;

% a1=0.9638;
% a2=0.0449;

a1=0.9628;
a2=0.0499;

% a1=0.9618;
% a2=0.0519;


% a1=0.9638;
% a2=0.0469;

a3=sqrt(1-a1.^2-a2.^2);
Laxis=[a1 a2 a3]';
l=Laxis(1);m=Laxis(2);n=Laxis(3);
R=[1-l^2/(1+n),-l*m/(1+n),-l;-l*m/(1+n),1-m^2/(1+n),-m;l,m,n];
Xdata1=[Xdata1 p(1)];
Ydata1=[Ydata1 p(2)];
Zdata1=[Zdata1 p(3)];
NEWxyz=R*[Xdata1;Ydata1;Zdata1];                            
Xdata2=NEWxyz(1,:);Ydata2=NEWxyz(2,:);Zdata2=NEWxyz(3,:);

title('Raw Data Graph and Front Port Plane
')

% figure
% plot(Xdata2,Ydata2,'+')
% figure
% hist(Zdata2)
% Zzhou=sort(Zdata2)'

Xdata3=Xdata2-Xdata2(end);
Ydata3=Ydata2-Ydata2(end);
% figure
% plot(Xdata3,Ydata3,'+')

n1=length(Xdata3);

mark0=1;
for i=1:n1-1
    jl=sqrt(Xdata3(i).^2+Ydata3(i).^2);
    if jl<0.165 && jl>0.127
        Xdata4(mark0)=Xdata3(i);
        Ydata4(mark0)=Ydata3(i);
        Zdata4(mark0)=Zdata2(i);
        mark0=mark0+1;
    end
end
figure
plot3(Xdata2,Ydata2,Zdata2,'*')
title('Vertical columnar scatterplot
')
figure
plot(Xdata4,Ydata4,'+')

data4=[Xdata4' Ydata4' Zdata4'];
[~,I]=sort(data4(:,3));
data4s=data4(I,:);

n2=length(data4s);
qiepian1=data4s(n2-244:n2,:);

% qiepian2=data4s(1:400,:);
% n1=length(qiepian2);
% 
% mark1=1;
% for i=1:n1-1
%     jl=sqrt(qiepian2(i,1).^2+qiepian2(i,2).^2);
%     if jl<0.14
%         Xdata5(mark1)=qiepian2(i,1);
%         Ydata5(mark1)=qiepian2(i,2);
%         Zdata5(mark1)=qiepian2(i,3);
%         mark1=mark1+1;
%     end
% end
% newqiepian2=[Xdata5' Ydata5' Zdata5'];
% figure
% plot(newqiepian2(:,1),newqiepian2(:,2),'+')
% qiepian1=newqiepian2;
% figure
% plot(qiepian2(:,1),qiepian2(:,2),'+')

X1=qiepian1(:,1:2);
n3=length(X1(:,1));
yy=zeros(n3,1);
bb=[rand(1)*1000 rand(1) rand(1)];
fun=inline('X1(:,1).^2+X1(:,2).^2+aa(1)*X1(:,1)+aa(2)*X1(:,2)+aa(3)','aa','X1');
% aa=nlinfit(X1(:,1),X1(:,2),fun2,yy);
[aa,rr,J]=nlinfit(X1,yy,fun,bb)
vpa(aa,10)
X2=-aa(1)/2,Y2=-aa(2)/2
R=sqrt(aa(1)^2+aa(2)^2-4*aa(3))/2

qian_zhongxin=[0.0019 -0.0021 mean(data4s(n2-244:n2,3))];
qian_neijing=0.1332;

hou_zhongxin=[0.0092 -0.0287 mean(data4s(1:400,3))];
hou_waijing=0.1615;

xuanzhuan_xl=(qian_zhongxin-hou_zhongxin)';
xz_xl=xuanzhuan_xl/sqrt(sum(xuanzhuan_xl'*xuanzhuan_xl))

Laxis=xz_xl;
l=Laxis(1);m=Laxis(2);n=Laxis(3);
R=[1-l^2/(1+n),-l*m/(1+n),-l;-l*m/(1+n),1-m^2/(1+n),-m;l,m,n]; 
Xdata5=[Xdata4 qian_zhongxin(1) hou_zhongxin(1)];
Ydata5=[Ydata4 qian_zhongxin(2) hou_zhongxin(2)];
Zdata5=[Zdata4 qian_zhongxin(3) hou_zhongxin(3)];
NEWxyz1=R*[Xdata5;Ydata5;Zdata5];                             
Xdata6=NEWxyz1(1,:);Ydata6=NEWxyz1(2,:);Zdata6=NEWxyz1(3,:); 
Xdata6=Xdata6-Xdata6(end);
Ydata6=Ydata6-Ydata6(end);

plot3(Xdata6,Ydata6,Zdata6,'*')
figure
plot(Xdata6,Ydata6,'+')
title('Bottom Plane Projection Scattering Point Map
')   

data6=[Xdata6' Ydata6' Zdata6'];
[~,I]=sort(data6(:,3));
data6s=data6(I,:);

n3=length(data6s)-2;
qiepian3=data6s(n3-244:n3,:);

n4=((n3-245)/200);
for j=1:n4
    qiepian4=data6s(j*200-199:j*200,:);
    [ma1,I1]=max(qiepian4(:,2));
    Cline(j,1:3)=[0 qiepian4(I1,3) max(qiepian4(:,2))];
    [ma2,I2]=min(qiepian4(:,1));
    Dline(j,1:3)=[min(qiepian4(:,1)) qiepian4(I2,3) 0];
end
xuanzhua3=Cline(30,:)'-Cline(90,:)';
xz_xl3=xuanzhua3/sqrt(sum(xuanzhua3'*xuanzhua3))
Laxis=xz_xl3;
l=Laxis(1);m=Laxis(2);n=Laxis(3);
R3=[1-l^2/(1+n),-l*m/(1+n),-l;-l*m/(1+n),1-m^2/(1+n),-m;l,m,n]; 
Line_newx=[Cline(:,1)'];
Line_newy=[ Cline(:,2)'];
Line_newz=[Cline(:,3)'];

NEWline=R3*[Line_newx;Line_newy;Line_newz];                    
NEWline=NEWline';
NEWline(:,2)=NEWline(:,2)+0.079;


xuanzhua4=Dline(30,:)'-Dline(94,:)';
xz_xl4=xuanzhua4/sqrt(sum(xuanzhua4'*xuanzhua4))
Laxis=xz_xl4;
l=Laxis(1);m=Laxis(2);n=Laxis(3);
R4=[1-l^2/(1+n),-l*m/(1+n),-l;-l*m/(1+n),1-m^2/(1+n),-m;l,m,n];
Line_newx0=[Dline(:,1)'];
Line_newy0=[Dline(:,2)'];
Line_newz0=[Dline(:,3)'];

NEWline0=R4*[Line_newx0;Line_newy0;Line_newz0];                              
NEWline0=NEWline0';
NEWline0(:,1)=NEWline0(:,1)-0.0208;

figure
% plot(qiepian3(:,1),qiepian3(:,2),'*')
% plot3(Cline(8:n4,1),Cline(8:n4,2),Cline(8:n4,3),'*')
hold on
% plot3(Dline(11:n4,1),Dline(11:n4,2),Dline(11:n4,3),'+')

plot3(-NEWline(11:n4,1),-NEWline(11:n4,3),NEWline(11:n4,2))

plot3(NEWline0(11:n4,1),-NEWline0(11:n4,3),NEWline0(11:n4,2))
hold on
plot3([data6(n3+1,1) data6(n3+2,1)],[data6(n3+1,3) data6(n3+2,3)],[data6(n3+1,2) data6(n3+2,2)])

hold on
r1=0.1625;
r2=0.1625;
ym1=-5.9265;
ym2=-11.7503;
t=-pi:0.1:pi;
x3=r1*sin(t);
z3=r1*cos(t);
y3=-5.9265+0*t;

x4=r2*sin(t);
z4=r2*cos(t);
y4=-11.7503+0*t;
plot3(x3,y3,z3)
hold on
plot3(x4,y4,z4)
plot3([0 0],[ym1 ym2],[r1 r2])
plot3([-r1 -r2],[ym1 ym2],[0 0])


eps=0.0002;
n5=length(NEWline);
for k=11:n5
    wuchaC(k-10)=sqrt((NEWline(k,2)-r1).^2);
    wuchaD(k-10)=sqrt((NEWline0(k,1)+r2).^2);
    if wuchaC(k-10)>eps
        plot3(-NEWline(k,1),-NEWline(k,3),NEWline(k,2),'k*')
        hold on
    end
     if wuchaD(k-10)>eps
        plot3(NEWline0(k,1),-NEWline0(k,3),NEWline0(k,2),'k*')
        hold on
    end
end
title('Straightness error diagram
')
% set(get(gca,'XLabel'),'FontSize',15)
% set(get(gca,'YLabel'),'FontSize',15)
% set(get(gca,'TITLE'),'FontSize',15)
% set(gca,'FontSize',15)
% wuchaC
% wuchaD









